/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.messaging.exchange;

import java.util.logging.Logger;

import javax.jbi.servicedesc.ServiceEndpoint;
import javax.xml.namespace.QName;

import org.ow2.petals.jbi.messaging.exchange.PetalsMessageExchange;
import org.ow2.petals.jbi.messaging.exchange.impl.DefaultMessageExchangeFactory;

/**
 * @author Nicolas Oddoux - EBM WebSourcing
 * @author Victor Noël - Linagora
 */
public class PersistedMessageExchangeFactoryImpl extends DefaultMessageExchangeFactory {

    protected PersistedMessageExchangeFactoryImpl(final ServiceEndpoint consumerEndpoint,
            final ServiceEndpoint targetEndpoint, final QName targetInterface, final QName targetService,
            final Logger logger) {
        super(consumerEndpoint, targetEndpoint, targetInterface, targetService, logger);
    }

    public static PersistedMessageExchangeFactoryImpl create(final ServiceEndpoint consumerEndpoint,
            final Logger logger) {
        return new PersistedMessageExchangeFactoryImpl(consumerEndpoint, null, null, null, logger);
    }

    public static PersistedMessageExchangeFactoryImpl createForEndpoint(final ServiceEndpoint consumerEndpoint,
            final Logger logger, final ServiceEndpoint targetEndpoint) {
        return new PersistedMessageExchangeFactoryImpl(consumerEndpoint, targetEndpoint, null, null, logger);
    }

    public static PersistedMessageExchangeFactoryImpl createForInterface(final ServiceEndpoint consumerEndpoint,
            final Logger logger, final QName targetInterface) {
        return new PersistedMessageExchangeFactoryImpl(consumerEndpoint, null, targetInterface, null, logger);
    }

    public static PersistedMessageExchangeFactoryImpl createForService(final ServiceEndpoint consumerEndpoint,
            final Logger logger, final QName targetService) {
        return new PersistedMessageExchangeFactoryImpl(consumerEndpoint, null, null, targetService, logger);
    }

    @Override
    protected PetalsMessageExchange buildExchange() {
        PetalsMessageExchange mex = super.buildExchange();
        return new PersistedMessageExchangeImpl(mex);
    }
}
